<template>
  <div class="app-container">
    <el-row :gutter="20">
      <!--部门数据-->
      <el-col :span="4" :xs="24">
        <div class="head-container">
          <el-input v-model="deptName" placeholder="请输入部门名称" clearable size="small" prefix-icon="el-icon-search" style="margin-bottom: 20px" />
        </div>
        <div class="head-container">
          <el-tree :data="deptOptions" :props="defaultProps" :expand-on-click-node="false" :filter-node-method="filterNode" ref="tree"  @node-click="handleNodeClick" />
        </div>
      </el-col>
      <!--用户数据-->
      <el-col :span="20" :xs="24">
        <el-form  :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="100px">
          <el-form-item label="员工后台昵称" prop="nickName">
            <el-input v-model="queryParams.nickName" placeholder="请输入员工后台昵称" clearable size="small" style="width: 240px" @keyup.enter.native="handleQuery" />
          </el-form-item>
          <el-form-item label="手机号码" prop="phonenumber">
            <el-input v-model="queryParams.phonenumber" placeholder="请输入手机号码" clearable size="small" style="width: 240px" @keyup.enter.native="handleQuery" />
          </el-form-item>
          <el-form-item label="状态" prop="status">
            <el-select v-model="queryParams.status" placeholder="员工状态" clearable size="small" style="width: 240px" @change="handleQuery">
              <el-option v-for="dict in statusOptions" :key="dict.dictValue" :label="dict.dictLabel" :value="dict.dictValue" />
            </el-select>
          </el-form-item>
          <el-form-item label="企微状态" prop="qwStatus">
            <el-select v-model="queryParams.qwStatus" placeholder="企微绑定状态" clearable size="small" style="width: 240px"  @change="handleQuery">
              <el-option v-for="dict in qwStatusOptions" :key="dict.dictValue" :label="dict.dictLabel" :value="dict.dictValue" />
            </el-select>
          </el-form-item>

          <el-form-item label="创建时间">
            <el-date-picker v-model="dateRange" size="small" style="width: 240px" value-format="yyyy-MM-dd" type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期"></el-date-picker>
          </el-form-item>
          <el-form-item>
            <el-button  icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
            <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>

        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button  plain type="primary" icon="el-icon-plus" size="mini" @click="handleAdd" v-hasPermi="['company:user:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button  plain type="success" icon="el-icon-edit" size="mini" :disabled="single" @click="handleUpdate" v-hasPermi="['company:user:edit']">修改</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button  plain type="danger" icon="el-icon-delete" size="mini" :disabled="multiple" @click="handleDelete" v-hasPermi="['company:user:remove']">删除</el-button>
          </el-col>
          <!-- <el-col :span="1.5">
            <el-button  plain type="info" icon="el-icon-upload2" size="mini" @click="handleImport" v-hasPermi="['company:user:import']">导入</el-button>
          </el-col> -->
          <el-col :span="1.5">
            <el-button  plain type="warning" icon="el-icon-download" size="mini" @click="handleExport" v-hasPermi="['company:user:export']">导出</el-button>
          </el-col>
          <el-col :span="1.5">
           <el-button
             type="primary"
             plain
             size="mini"
             @click="synOpen=true"
             v-hasPermi="['qw:user:sync']"
           >同步企微员工和部门</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button
              type="primary"
              plain
              size="mini"
              :disabled="multiple"
              @click="handerCompanyUserAreaList"
            >批量设置销售所属区域(原有的暂用)</el-button>
          </el-col>
          <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <el-table  height="500" border v-loading="loading" :data="userList" @selection-change="handleSelectionChange">
          <el-table-column type="selection" width="50" align="center" />
          <el-table-column label="ID" align="center" prop="userId" :show-overflow-tooltip="true" />
          <el-table-column label="员工后台账号" align="center" prop="userName" :show-overflow-tooltip="true" width="100" />
          <el-table-column label="员工后台昵称" align="center" prop="nickName" :show-overflow-tooltip="true" 员工后台  width="100"/>
          <el-table-column label="部门" align="center" prop="deptName" :show-overflow-tooltip="true" />
          <el-table-column label="手机号码" align="center" prop="phonenumber" width="120" />
          <el-table-column label="状态" align="center">
            <template slot-scope="scope">
              <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
            </template>
          </el-table-column>
          <el-table-column label="企微状态" align="center">
            <template slot-scope="scope">
              <dict-tag :options="qwStatusOptions" :value="scope.row.qwStatus"/>
            </template>
          </el-table-column>
          <el-table-column label="区域" align="center" prop="addressId">
          </el-table-column>
          <el-table-column label="创建时间"  sortable align="center" prop="createTime" width="160">
            <template slot-scope="scope">
              <span>{{ parseTime(scope.row.createTime) }}</span>
            </template>
          </el-table-column>
          <el-table-column label="操作" align="center" width="160" class-name="small-padding fixed-width">
            <template slot-scope="scope">
              <el-button
                v-if="scope.row.qwStatus == 0"
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="qwBind(scope.row)"
                v-hasPermi="['qw:user:bind']"
              >绑定企微</el-button>

              <el-button
                v-else
                size="mini"
                type="text"
                icon="el-icon-edit"
                @click="qwBind(scope.row)"
                v-hasPermi="['qw:user:bind']"
              >查或换绑企微</el-button>

              <el-button v-if="scope.row.userType !== '00'" size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['company:user:edit']">修改</el-button>
              <el-button v-if="scope.row.userType !== '00'" size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['company:user:remove']">删除</el-button>
              <el-button size="mini" type="text" icon="el-icon-key" @click="handleResetPwd(scope.row)" v-hasPermi="['company:user:resetPwd']">重置密码</el-button>
            </template>
          </el-table-column>
        </el-table>

        <pagination v-show="total>0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize" @pagination="getList" />
      </el-col>
    </el-row>
    <el-dialog title="绑定企微账号"  :visible.sync="qwOpen" width="800px" append-to-body >

      <el-form ref="form" :model="form"  label-width="80px" >
        <el-form-item label="查询"  prop="companyUserId">
          <el-button type="primary" icon="el-icon-search"  @click="selectQwUser()"  size="mini">搜索账号</el-button>
        </el-form-item>
        <el-form-item label="企微账号"  prop="companyUserId">

          <el-tag
            style="margin-left: 5px"
            size="medium"
            :key="id"
            v-for="id in qwUser"
            closable
            :disable-transitions="false"
            @close="handleClosegroupUser(id)">
            <span v-for="list in qwUserList" :key="list.qwUserId" v-if="list.id==id">{{list.qwUserName}}({{list.corpName}})
            </span>
          </el-tag>
        </el-form-item>

      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="qwSubmitForm">绑 定</el-button>
        <el-button @click="qwCancel">取 消</el-button>
      </div>
    </el-dialog>
    <el-dialog title="选择企微主体" :visible.sync="synOpen" width="800px" append-to-body>

      <el-form   label-width="80px">
        <el-form-item label="企微公司" prop="corpId">
          <el-select v-model="synform.corpId" placeholder="企微公司"  >
            <el-option
              v-for="dict in myQwCompanyList"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            />
          </el-select>
        </el-form-item>


      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="synSubmitForm">确 定</el-button>
        <el-button @click="synOpen=false">取 消</el-button>
      </div>
    </el-dialog>
    <!-- 添加或修改参数配置对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="700px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-row>
          <el-col :span="12">
<!--            <el-form-item label="员工账号" prop="userName">-->
<!--              <el-input v-model="form.userName" placeholder="请输入员工后台账号" />-->
<!--            </el-form-item>-->
            <el-form-item label="员工姓名" prop="nickName">
              <el-input v-model="form.nickName" placeholder="请输入员工后台昵称" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="归属部门" prop="deptId">
              <treeselect v-model="form.deptId" :options="deptOptions" :show-count="true" placeholder="请选择归属部门" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="手机号码" prop="phonenumber">
              <el-input v-model="form.phonenumber" placeholder="请输入手机号码" maxlength="11" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="邮箱" prop="email">
              <el-input v-model="form.email" placeholder="请输入邮箱" maxlength="50" />
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="员工账号" prop="userName">
              <el-input v-model="form.userName" placeholder="请输入员工工号" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item v-if="form.userId == undefined" label="用户密码" prop="password">
              <el-input v-model="form.password" placeholder="请输入用户密码" type="password" show-password />
            </el-form-item>
          </el-col>
        </el-row>

        <el-row>
          <el-col :span="12">
            <el-form-item label="员工性别">
              <el-select v-model="form.sex" placeholder="请选择">
                <el-option v-for="dict in sexOptions" :key="dict.dictValue" :label="dict.dictLabel" :value="dict.dictValue"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="状态">
              <el-radio-group v-model="form.status">
                <el-radio v-for="dict in statusOptions" :key="dict.dictValue" :label="dict.dictValue">{{dict.dictLabel}}</el-radio>
              </el-radio-group>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="12">
            <el-form-item label="岗位">
              <el-select v-model="form.postIds" multiple placeholder="请选择">
                <el-option v-for="item in postOptions" :key="item.postId" :label="item.postName" :value="item.postId" :disabled="item.status == 1"></el-option>
              </el-select>
            </el-form-item>
          </el-col>

          <el-col :span="12">
            <el-form-item label="角色">
              <el-select v-model="form.roleIds" multiple placeholder="请选择">
                <el-option v-for="item in roleOptions" :key="item.roleId" :label="item.roleName" :value="item.roleId" :disabled="item.status == 1"></el-option>
              </el-select>
            </el-form-item>
          </el-col>

        </el-row>
         <el-row>
          <el-col :span="12">
            <el-form-item label="身份证号">
              <el-input v-model="form.idCard" placeholder="请输入身份证号" maxlength="18" />
            </el-form-item>
          </el-col>
          <el-col :span="12">
            <el-form-item label="销售区域" prop="addressId">
              <el-select v-model="form.addressId"  filterable placeholder="请选择所属销售的区域" style="width: 200px;">
                <el-option
                  v-for="item in citysAreaList"
                  :key="item.cityId"
                  :label="item.cityName"
                  :value="item.cityId"
                ></el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
<!--        <el-row>-->
<!--          <el-col :span="24">-->
<!--            <el-form-item label="数据权限">-->
<!--              <el-radio-group v-model="form.userType">-->
<!--                <el-radio v-for="dict in userTypeOptions" :key="dict.dictValue" :label="dict.dictValue">{{dict.dictLabel}}</el-radio>-->
<!--              </el-radio-group>-->
<!--            </el-form-item>-->
<!--          </el-col>-->
<!--        </el-row>-->
        <el-row>
          <el-col :span="24">
            <el-form-item label="看课域名">
              <el-input
                v-model="form.domain"
                style="width: 250px"
                placeholder="请生成域名"
                @change="onDomainBlur"
                disabled
              ></el-input>
              <el-button type="primary" style="margin-left: 20px" @click="generateDomain">生成域名</el-button>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="24">
            <el-form-item label="备注">
              <el-input v-model="form.remark" type="textarea" placeholder="请输入内容"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

<!--    &lt;!&ndash; 用户导入对话框 &ndash;&gt;-->
<!--    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>-->
<!--      <el-upload ref="upload" :limit="1" accept=".xlsx, .xls" :headers="upload.headers" :action="upload.url + '?updateSupport=' + upload.updateSupport" :disabled="upload.isUploading" :on-progress="handleFileUploadProgress" :on-success="handleFileSuccess" :auto-upload="false" drag>-->
<!--        <i class="el-icon-upload"></i>-->
<!--        <div class="el-upload__text">-->
<!--          将文件拖到此处，或-->
<!--          <em>点击上传</em>-->
<!--        </div>-->
<!--        <div class="el-upload__tip" slot="tip">-->
<!--          <el-checkbox v-model="upload.updateSupport" />是否更新已经存在的用户数据-->
<!--          <el-link type="info" style="font-size:12px" @click="importTemplate">下载模板</el-link>-->
<!--        </div>-->
<!--        <div class="el-upload__tip" style="color:red" slot="tip">提示：仅允许导入“xls”或“xlsx”格式文件！</div>-->
<!--      </el-upload>-->
<!--      <div slot="footer" class="dialog-footer">-->
<!--        <el-button type="primary" @click="submitFileForm">确 定</el-button>-->
<!--        <el-button @click="upload.open = false">取 消</el-button>-->
<!--      </div>-->
<!--    </el-dialog>-->
    <el-dialog :title="user.title" :visible.sync="user.open" width="1000px" append-to-body>
      <selectUser ref="selectUser" @bindQwUser="bindQwUser"></selectUser>
    </el-dialog>


    <el-dialog :title="companyUserArea.title" :visible.sync="companyUserArea.open" width="300px" append-to-body>
      <el-select v-model="addressId"  filterable placeholder="请选择所属销售的区域" style="width: 200px;">
        <el-option
          v-for="item in citysAreaList"
          :key="item.cityId"
          :label="item.cityName"
          :value="item.cityId"
        ></el-option>
      </el-select>
      <div slot="footer" style="text-align: center;">
        <el-button type="primary" @click="submitFormArea(addressId)">确 定</el-button>
        <el-button @click="cancelArea">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  qwList,
  delUser,
  addUser,
  getUser,
  updateUser,
  exportUser,
  resetUserPwd,
  changeUserStatus,
  importTemplate,
  getCitysAreaList,
  updateCompanyUserAreaList,
  generateSubDomain
} from "../../../api/company/companyUser";
import { getToken } from "@/utils/auth";
import { treeselect } from "@/api/company/companyDept";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {bindQwUser, getQwUserList, addQwUser, getQwUser, getQwUserByIds} from '@/api/qw/user';
import { syncDept } from '@/api/qw/qwDept';
import { getMyQwUserList,getMyQwCompanyList } from "@/api/qw/user";
import  selectUser  from "@/views/company/components/selectQwUser.vue";
export default {
  name: "User",
  components: { Treeselect ,selectUser},
  data() {
    return {
      // 遮罩层
      loading: false,
      qwUserList:[],
      qwUserId:[],
      myQwCompanyList:[],
      qwUser:[],
      user:{
        open:false,
        title:"搜索企业"
      },
      // 选中数组
      ids: [],
      synform:{corpId:null},
      synOpen:false,
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户表格数据
      userList: null,
      // 弹出层标题
      title: "",
      // 部门树选项
      deptOptions: undefined,
      // 是否显示弹出层
      open: false,
      qwOpen:false,
      // 部门名称
      deptName: undefined,
      // 日期范围
      dateRange: [],
      // 状态数据字典
      statusOptions: [],
      // 性别状态字典
      sexOptions: [],
      // 岗位选项
      postOptions: [],
      // 角色选项
      roleOptions: [],
      userTypeOptions:[
        { "dictLabel": "临时管理员","dictValue": "02"},
        { "dictLabel": "普通用户","dictValue": "01"}
      ],
      qwForm:{
        id:null,
        companyUserId:null,
      },
      companyUserArea:{
        open:false,
        title:"分配区域",
      },
      //选择的区域
      addressId:null,

      citysAreaList:[],
      // 表单参数
      form: {},
      defaultProps: {
        children: "children",
        label: "label",
      },
      // // 用户导入参数
      // upload: {
      //   // 是否显示弹出层（用户导入）
      //   open: false,
      //   // 弹出层标题（用户导入）
      //   title: "",
      //   // 是否禁用上传
      //   isUploading: false,
      //   // 是否更新已经存在的用户数据
      //   updateSupport: 0,
      //   // 设置上传的请求头部
      //   headers: { Authorization: "Bearer " + getToken() },
      //   // 上传的地址
      //   url: process.env.VUE_APP_BASE_API + "/system/user/importData",
      // },
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        userName: null,
        phonenumber: null,
        status: null,
        deptId: null,
        qwStatus:null,
      },
      qwStatusOptions:[],
      // 表单校验
      rules: {
        userName: [
          { required: true, message: "员工工号不能为空", trigger: "blur" },
        ],
        nickName: [
          { required: true, message: "员工姓名不能为空", trigger: "blur" },
        ],
        deptId: [
          { required: true, message: "归属部门不能为空", trigger: "blur" },
        ],
        addressId: [
          { required: true, message: "销售所属区域不能为空", trigger: "blur" },
        ],
        password: [
          { required: true, message: "员工密码不能为空", trigger: "blur" },
          {
            pattern: /^(?=.*[A-Za-z])(?=.*\d)(?=.*[^A-Za-z0-9]).{8,20}$/,
            message: "密码长度为 8-20 位，必须包含字母、数字和特殊字符",
            trigger: ["blur", "change"],
          }
        ],
        idCard: [
          { required: true, message: "身份证号不能为空", trigger: "blur" },
        ],
        // email: [
        //   { required: true, message: "邮箱地址不能为空", trigger: "blur" },
        //   {
        //     type: "email",
        //     message: "'请输入正确的邮箱地址",
        //     trigger: ["blur", "change"],
        //   },
        // ],
        phonenumber: [
          { required: true, message: "手机号码不能为空", trigger: "blur" },
          {
            pattern: /^1[3|4|5|6|7|8|9][0-9]\d{8}$/,
            message: "请输入正确的手机号码",
            trigger: "blur",
          },
        ],
      },
    };
  },
  watch: {
    // 根据名称筛选部门树
    deptName(val) {
      this.$refs.tree.filter(val);
    },
  },
  created() {
    this.getList();
    this.getTreeselect();
    this.getDicts("sys_normal_disable").then((response) => {
      this.statusOptions = response.data;
    });
    this.getDicts("company_user_sex").then((response) => {
      this.sexOptions = response.data;
    });
    this.getDicts("sys_qw_user_status").then(response => {
          this.qwStatusOptions = response.data;
    });
    getCitysAreaList().then(res=>{
      this.citysAreaList=res.data;
    })
    getMyQwCompanyList().then(response => {
      this.myQwCompanyList = response.data;
    });
  },
  methods: {
    onDomainBlur() {
      if (this.form.domain!=null){
        let value = this.form.domain.trim();

        // 强制只保留第一个 http://
        const httpCount = (value.match(/http:\/\//g) || []).length;
        if (httpCount > 1) {
          value = value.replace(/(http:\/\/)+/, 'http://'); // 只留第一个
        }

        // 如果不是 http:// 开头，自动补充
        if (!value.startsWith('http://')) {
          value = 'http://' + value.replace(/^https?:\/\//, ''); // 去掉其他 http(s):// 再补
        }

        this.form.domain = value; // 重新赋值，保证输入正确

        // 正则校验最终格式，提醒用户
        const domainPattern = /^http:\/\/([a-zA-Z0-9-]+\.)+[a-zA-Z]{2,}$/;
        if (!domainPattern.test(this.form.domain)) {
          return  this.$message.error('请输入正确格式的域名，如：http://xxx.xxx.com');
        }
      }

    },
    /** 查询用户列表 */
    getList() {
      this.loading = true;
      qwList(this.addDateRange(this.queryParams, this.dateRange)).then(
        (response) => {
          this.userList = response.rows;
          this.total = response.total;
          this.loading = false;
          console.log(" this.userList ", this.userList )
        }
      );
    },
    selectQwUser(){
      this.user.open=true;
    },
    handleClosegroupUser(list){
      const index = this.qwUser.findIndex(t => t === list);
      if (index !== -1) {
        this.qwUser.splice(index, 1);
      }
    },
    /** 查询部门下拉树结构 */
    getTreeselect() {
      treeselect().then((response) => {
        this.deptOptions = response.data;
      });
    },
    // 筛选节点
    filterNode(value, data) {
      if (!value) return true;
      return data.label.indexOf(value) !== -1;
    },
    // 节点单击事件
    handleNodeClick(data) {
      this.queryParams.deptId = data.id;
      this.getList();
    },
    // 用户状态修改
    handleStatusChange(row) {
      let text = row.status === "0" ? "启用" : "停用";
      this.$confirm(
        '确认要"' + text + '""' + row.userName + '"用户吗?',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return changeUserStatus(row.userId, row.status);
        })
        .then(() => {
          this.msgSuccess(text + "成功");
        })
        .catch(function () {
          row.status = row.status === "0" ? "1" : "0";
        });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },

    submitFormArea(address){
      const uIds = this.ids;

      if (address == null){
        this.$message.error("请选择地区");
        return;
      }
      updateCompanyUserAreaList({userIds:uIds,addressId:address}).then(res=>{
        this.companyUserArea.open=false;
        this.getList();
        this.msgSuccess("操作成功");

      })

    },
    cancelArea(){
      this.companyUserArea.open=false;
      this.addressId=null;
    },
    qwCancel() {
      this.qwOpen = false;
      this.qwUserId=null;
    },

    handerCompanyUserAreaList(){
      this.companyUserArea.open=true;
    },
    // 表单重置
    reset() {
      this.form = {
        userId: undefined,
        deptId: undefined,
        userName: undefined,
        nickName: undefined,
        password: undefined,
        idCard: undefined,
        phonenumber: undefined,
        userType: "01",
        email: undefined,
        sex: undefined,
        status: "0",
        remark: undefined,
        domain: null,
        postIds: [],
        roleIds: [],
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.page = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.userId);
      this.single = selection.length != 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.getTreeselect();
      getUser().then((response) => {
        this.postOptions = response.posts;
        this.roleOptions = response.roles;
        this.open = true;
        this.title = "添加员工";
        this.form.password = "ylrz147..";
      });
    },
    qwBind(row){
      this.qwUser=[];
      this.qwUserList=[];
      this.qwForm.companyUserId=row.userId
      getUser(row.userId).then((response) => {
        if(response.data.qwUserId!=null){
           this.qwUser=((response.data.qwUserId).split(",").map(Number))
          getQwUserByIds(this.qwUser).then(res => {
            this.qwUserList=res.data;
          })
           // this.qwUser.forEach(item => {
           //     getQwUser(item).then(response => {
           //         this.qwUserList.push(response.data);
           //     });
           // });
        }
        this.qwOpen = true;
      });

    },

    bindQwUser(row){
      this.user.open=false;


        if (!this.qwUserList.some(item => item.id == row.id)) {
          this.qwUserList.push(row)
        }

        if (!this.qwUser.some(item => item == row.id)) {
          this.qwUser.push(row.id);
        }

    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getTreeselect();
      const userId = row.userId || this.ids;
      getUser(userId).then((response) => {
        this.form = response.data;
        this.postOptions = response.posts;
        this.roleOptions = response.roles;
        this.form.postIds = response.postIds;
        this.form.roleIds = response.roleIds;
        this.open = true;
        this.title = "修改员工";
        this.form.password = "";
      });
    },
    /** 重置密码按钮操作 */
    handleResetPwd(row) {
      this.$prompt('请输入"' + row.userName + '"的新密码', "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        inputPlaceholder: "8-20 位，包含字母、数字和特殊字符",
        inputValidator: (value) => {
          const pattern = /^(?=.*[A-Za-z])(?=.*\d)(?=.*[^A-Za-z0-9]).{8,20}/;
          const hasChinese = /[\u4e00-\u9fa5]/.test(value);
          const hasFullWidth = /[！-～]/.test(value);

          if (hasChinese) return '不能包含中文字符';
          if (hasFullWidth) return '不能包含全角符号，请使用英文输入法';
          if (!pattern.test(value)) return '密码格式错误：需包含字母、数字和英文特殊字符，长度为 8-20 位';

          return true;
        }
      })
        .then(({ value }) => {
          resetUserPwd(row.userId, value).then((response) => {
            if (response.code === 200) {
              this.msgSuccess("修改成功，新密码是：" + value);
            }
          });
        })
        .catch(() => {});
    },
    /** 提交按钮 */
    submitForm: function () {

      this.onDomainBlur();

      const domainPattern = /^http:\/\/([a-zA-Z0-9-]+\.)+[a-zA-Z]{2,}$/;
      if (this.form.domain!=null && !domainPattern.test(this.form.domain)) {
        this.$message.error('请输入正确格式的域名，如：http://xxx.xxx.com');
        return;
      }

      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.userId != undefined) {
            updateUser(this.form).then((response) => {
              if (response.code === 200) {
                this.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              }
            });
          } else {
            addUser(this.form).then((response) => {
              if (response.code === 200) {
                this.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              }
            });
          }
        }
      });
    },
    /**
    * 同步企业微信员工
    */
    synSubmitForm() {
      this.synOpen=false;
      this.loading=true;
      this.msgSuccess("");

      let loadingRock = this.$loading({
        lock: true,
        text: '同步中.....请等待.....请不要重复点击！！',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      });


      addQwUser(this.synform.corpId).then(response => {
        this.msgSuccess("同步成功");
        this.getList();
        this.synOpen=false;
      }).finally(()=>{
        this.loading=false;
        this.synOpen=false;
        loadingRock.close();
      });
    },
    /**
    * 同步企业微信部门
    */
    qwSyncDept(){
      syncDept().then(response => {
        this.msgSuccess("同步成功");
        this.getList();
      }).catch(()=>{
        this.msgError("同步失败:"+response.msg);
      })
    },
    qwSubmitForm(){

      let loadingRock = this.$loading({
        lock: true,
        text: '绑定中.....同步客户信息中.....',
        spinner: 'el-icon-loading',
        background: 'rgba(0, 0, 0, 0.7)'
      });

      this.qwForm.id = (this.qwUser).join(',');

      bindQwUser(this.qwForm).then(response => {
        this.msgSuccess("绑定成功");
        this.qwOpen = false;
        this.getList();
        this.qwUserId=null;
        this.qwUser=[];
      }).finally(res=>{
        loadingRock.close()
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const userIds = row.userId || this.ids;
      this.$confirm(
        '是否确认删除员工编号为"' + userIds + '"的数据项?【注意：删除后绑定的企业微信相关信息可能会错乱！！】',
        "警告",
        {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning",
        }
      )
        .then(function () {
          return delUser(userIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(function () {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有用户数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return exportUser(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        })
        .catch(function () {});
    },
    // /** 导入按钮操作 */
    // handleImport() {
    //   this.upload.title = "用户导入";
    //   this.upload.open = true;
    // },
    /** 下载模板操作 */
    importTemplate() {
      importTemplate().then((response) => {
        this.download(response.msg);
      });
    },
    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert(response.msg, "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    generateDomain(){
      let queryParams;
      if(this.form.userId){
        queryParams= {
          'userId': this.form.userId,
        }
      }
      generateSubDomain(queryParams).then(response => {
        this.form.domain=response.data
      });
    },
  },
};
</script>
